unit intf;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, lua52, series;
type
  TluaLReg = array of luaL_Reg;
var
  LUA: Plua_State;
  data: TStringList;
  lib : array of luaL_Reg;
  //lib : PluaL_Reg;
  i: Integer;
implementation
function _get_series(ss: string): TSeries;
var
  i : Integer;
begin
  i := data.IndexOf(ss);
  if i >= 0 then begin
    Result := TSeries(data.Objects[i]);
  end else begin
    Result := TSeries.Create;
    data.AddObject(ss, Result);
  end;
end;

//dat_upd('series_name', 'serie_name', data) -- data can be number or string
function l_dat_upd(L: Plua_State): LongInt cdecl;
var
  ss_name, s_name: string;
  s : TSeries;
  n : Integer;
begin
  Result := 2;
  n := lua_gettop(L);
  if n = 3 then begin
    ss_name := lua_tostring(L, -3);
    s_name := lua_tostring(L, -2);
    case lua_type(L, -1) of
      LUA_TNUMBER: begin
        s := _get_series(ss_name);
        s.Append(s_name, lua_tonumber(L, -1));
        lua_pushnumber(L, 0);
        lua_pushnil(L);
      end;
      LUA_TSTRING: begin
        s := _get_series(ss_name);
        s.Append(s_name, lua_tostring(L, -1));
        lua_pushnumber(L, 0);
        lua_pushnil(L);
      end
      else
        lua_pushnumber(L, 1);
        lua_pushstring(L, 'error: wrong type for argument #3, number or string expected');
    end;
  end else begin
    lua_pushnumber(L, 1);
    lua_pushstring(L, 'error: number of arguments expected: 3, given: ' + IntToStr(n));
  end;
end;

//dat_clr('series_name') --if no series_name given, all data is cleared
function l_dat_clr(L: Plua_State): LongInt cdecl;
var
  i, n : Integer;
  name: string;
begin
  Result := 2;
  n := lua_gettop(L);
  if n = 0 then begin
    lua_pushnumber(L, 0);
    lua_pushnumber(L, data.Count);
    for i := 0 to data.Count - 1 do TSeries(data.Objects[i]).Free;
    data.Clear;
  end else if n = 1 then begin
    case lua_type(L, -1) of
      LUA_TSTRING: begin
        name := lua_tostring(L, -1);
        i := data.IndexOf(name);
        if i < 0 then begin
          lua_pushnumber(L, 1);
          lua_pushstring(L, 'error: specified data series no found: ' + name);
        end else begin
          TSeries(data.Objects[i]).Free;
          data.Delete(i);
          lua_pushnumber(L, 0);
          lua_pushnil(L);
        end;
      end
      else
        lua_pushnumber(L, 2);
        lua_pushstring(L, 'error: wrong type for argument #1, string expected');
    end;
  end else begin
    lua_pushnumber(L, 2);
    lua_pushstring(L, 'error: number of arguments expected: 0 or 1, given: ' + IntToStr(n));
  end;
end;

initialization
data := TStringList.Create;
data.Sorted := True;
LUA := luaL_newstate();
luaL_openlibs(LUA);
//SetLength(TluaLReg(lib), 2);
SetLength(lib, 2);
lib[0].name := 'update';
lib[0].func := @l_dat_upd;
lib[1].name := 'clear';
lib[1].func := @l_dat_clr;
luaL_newlib(LUA, lib);
lua_setglobal(LUA, 'data');
finalization
lua_close(LUA);
for i := 0 to data.Count - 1 do TSeries(data.Objects[i]).Free;
data.Free;
end.

